javax.lang.model.util

## Class ElementScanner6<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>
  - - javax.lang.model.util.ElementScanner6<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    ElementVisitor<R,P>

      @SupportedSourceVersion(value=RELEASE_6)
      public class ElementScanner6<R,P>
      extends AbstractElementVisitor6<R,P>

  A scanning visitor of program elements with default behavior appropriate for the `RELEASE_6` source version. The `visitXYZ` methods in this class scan their component elements by calling `scan` on their enclosed elements, parameters, etc., as indicated in the individual method specifications. A subclass can control the order elements are visited by overriding the `visitXYZ` methods. Note that clients of a scanner may get the desired behavior be invoking `v.scan(e, p)` rather than `v.visit(e, p)` on the root objects of interest.

  When a subclass overrides a `visitXYZ` method, the new method can cause the enclosed elements to be scanned in the default way by calling `super.visitXYZ`. In this fashion, the concrete visitor can control the ordering of traversal over the component elements with respect to the additional processing; for example, consistently calling `super.visitXYZ` at the start of the overridden methods will yield a preorder traversal, etc. If the component elements should be traversed in some other order, instead of calling `super.visitXYZ`, an overriding visit method should call `scan` with the elements in the desired order.

  Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

  WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new element scanner visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Since:
    1.6

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected R` | `DEFAULT_VALUE` The specified default value.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ElementScanner6()` Constructor for concrete subclasses; uses `null` for the default value.
    `protected` | `ElementScanner6(R defaultValue)` Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `R` | `scan(Element e)` Convenience method equivalent to `v.scan(e, null)`.
    `R` | `scan(Element e, P p)` Processes an element by calling `e.accept(this, p)`; this method may be overridden by subclasses.
    `R` | `scan(Iterable<? extends Element> iterable, P p)` Iterates over the given elements and calls `scan(Element, P)` on each one.
    `R` | `visitExecutable(ExecutableElement e, P p)` Visits an executable element.
    `R` | `visitPackage(PackageElement e, P p)` Visits a package element.
    `R` | `visitType(TypeElement e, P p)` Visits a type element.
    `R` | `visitTypeParameter(TypeParameterElement e, P p)` Visits a type parameter element.
    `R` | `visitVariable(VariableElement e, P p)` Visits a variable element.

    - ### Methods inherited from class javax.lang.model.util.AbstractElementVisitor6

      `visit, visit, visitUnknown`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_VALUE

          protected final R DEFAULT_VALUE

      The specified default value.

  - ### Constructor Detail

    - #### ElementScanner6

          protected ElementScanner6()

      Constructor for concrete subclasses; uses `null` for the default value.

    - #### ElementScanner6

          protected ElementScanner6(R defaultValue)

      Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Detail

    - #### scan

          public final R scan(Iterable<? extends Element> iterable,
               P p)

      Iterates over the given elements and calls `scan(Element, P)` on each one. Returns the result of the last call to `scan` or `DEFAULT_VALUE` for an empty iterable.
      Parameters:
        `iterable` - the elements to scan
        `p` - additional parameter
      Returns:
        the scan of the last element or `DEFAULT_VALUE` if no elements

    - #### scan

          public R scan(Element e,
               P p)

      Processes an element by calling `e.accept(this, p)`; this method may be overridden by subclasses.
      Returns:
        the result of visiting `e`.

    - #### scan

          public final R scan(Element e)

      Convenience method equivalent to `v.scan(e, null)`.
      Returns:
        the result of scanning `e`.

    - #### visitPackage

          public R visitPackage(PackageElement e,
                       P p)

      Visits a package element. This implementation scans the enclosed elements.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

    - #### visitType

          public R visitType(TypeElement e,
                    P p)

      Visits a type element. This implementation scans the enclosed elements.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

    - #### visitVariable

          public R visitVariable(VariableElement e,
                        P p)

      Visits a variable element. This implementation scans the enclosed elements.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

    - #### visitExecutable

          public R visitExecutable(ExecutableElement e,
                          P p)

      Visits an executable element. This implementation scans the parameters.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

    - #### visitTypeParameter

          public R visitTypeParameter(TypeParameterElement e,
                             P p)

      Visits a type parameter element. This implementation scans the enclosed elements.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.